// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from urinterfaces:action/SetMode.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__ACTION__DETAIL__SET_MODE__FUNCTIONS_H_
#define URINTERFACES__ACTION__DETAIL__SET_MODE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "urinterfaces/msg/rosidl_generator_c__visibility_control.h"

#include "urinterfaces/action/detail/set_mode__struct.h"

/// Initialize action/SetMode message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * urinterfaces__action__SetMode_Goal
 * )) before or use
 * urinterfaces__action__SetMode_Goal__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Goal__init(urinterfaces__action__SetMode_Goal * msg);

/// Finalize action/SetMode message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_Goal__fini(urinterfaces__action__SetMode_Goal * msg);

/// Create action/SetMode message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * urinterfaces__action__SetMode_Goal__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_Goal *
urinterfaces__action__SetMode_Goal__create();

/// Destroy action/SetMode message.
/**
 * It calls
 * urinterfaces__action__SetMode_Goal__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_Goal__destroy(urinterfaces__action__SetMode_Goal * msg);

/// Check for action/SetMode message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Goal__are_equal(const urinterfaces__action__SetMode_Goal * lhs, const urinterfaces__action__SetMode_Goal * rhs);

/// Copy a action/SetMode message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Goal__copy(
  const urinterfaces__action__SetMode_Goal * input,
  urinterfaces__action__SetMode_Goal * output);

/// Initialize array of action/SetMode messages.
/**
 * It allocates the memory for the number of elements and calls
 * urinterfaces__action__SetMode_Goal__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Goal__Sequence__init(urinterfaces__action__SetMode_Goal__Sequence * array, size_t size);

/// Finalize array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_Goal__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_Goal__Sequence__fini(urinterfaces__action__SetMode_Goal__Sequence * array);

/// Create array of action/SetMode messages.
/**
 * It allocates the memory for the array and calls
 * urinterfaces__action__SetMode_Goal__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_Goal__Sequence *
urinterfaces__action__SetMode_Goal__Sequence__create(size_t size);

/// Destroy array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_Goal__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_Goal__Sequence__destroy(urinterfaces__action__SetMode_Goal__Sequence * array);

/// Check for action/SetMode message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Goal__Sequence__are_equal(const urinterfaces__action__SetMode_Goal__Sequence * lhs, const urinterfaces__action__SetMode_Goal__Sequence * rhs);

/// Copy an array of action/SetMode messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Goal__Sequence__copy(
  const urinterfaces__action__SetMode_Goal__Sequence * input,
  urinterfaces__action__SetMode_Goal__Sequence * output);

/// Initialize action/SetMode message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * urinterfaces__action__SetMode_Result
 * )) before or use
 * urinterfaces__action__SetMode_Result__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Result__init(urinterfaces__action__SetMode_Result * msg);

/// Finalize action/SetMode message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_Result__fini(urinterfaces__action__SetMode_Result * msg);

/// Create action/SetMode message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * urinterfaces__action__SetMode_Result__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_Result *
urinterfaces__action__SetMode_Result__create();

/// Destroy action/SetMode message.
/**
 * It calls
 * urinterfaces__action__SetMode_Result__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_Result__destroy(urinterfaces__action__SetMode_Result * msg);

/// Check for action/SetMode message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Result__are_equal(const urinterfaces__action__SetMode_Result * lhs, const urinterfaces__action__SetMode_Result * rhs);

/// Copy a action/SetMode message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Result__copy(
  const urinterfaces__action__SetMode_Result * input,
  urinterfaces__action__SetMode_Result * output);

/// Initialize array of action/SetMode messages.
/**
 * It allocates the memory for the number of elements and calls
 * urinterfaces__action__SetMode_Result__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Result__Sequence__init(urinterfaces__action__SetMode_Result__Sequence * array, size_t size);

/// Finalize array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_Result__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_Result__Sequence__fini(urinterfaces__action__SetMode_Result__Sequence * array);

/// Create array of action/SetMode messages.
/**
 * It allocates the memory for the array and calls
 * urinterfaces__action__SetMode_Result__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_Result__Sequence *
urinterfaces__action__SetMode_Result__Sequence__create(size_t size);

/// Destroy array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_Result__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_Result__Sequence__destroy(urinterfaces__action__SetMode_Result__Sequence * array);

/// Check for action/SetMode message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Result__Sequence__are_equal(const urinterfaces__action__SetMode_Result__Sequence * lhs, const urinterfaces__action__SetMode_Result__Sequence * rhs);

/// Copy an array of action/SetMode messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Result__Sequence__copy(
  const urinterfaces__action__SetMode_Result__Sequence * input,
  urinterfaces__action__SetMode_Result__Sequence * output);

/// Initialize action/SetMode message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * urinterfaces__action__SetMode_Feedback
 * )) before or use
 * urinterfaces__action__SetMode_Feedback__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Feedback__init(urinterfaces__action__SetMode_Feedback * msg);

/// Finalize action/SetMode message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_Feedback__fini(urinterfaces__action__SetMode_Feedback * msg);

/// Create action/SetMode message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * urinterfaces__action__SetMode_Feedback__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_Feedback *
urinterfaces__action__SetMode_Feedback__create();

/// Destroy action/SetMode message.
/**
 * It calls
 * urinterfaces__action__SetMode_Feedback__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_Feedback__destroy(urinterfaces__action__SetMode_Feedback * msg);

/// Check for action/SetMode message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Feedback__are_equal(const urinterfaces__action__SetMode_Feedback * lhs, const urinterfaces__action__SetMode_Feedback * rhs);

/// Copy a action/SetMode message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Feedback__copy(
  const urinterfaces__action__SetMode_Feedback * input,
  urinterfaces__action__SetMode_Feedback * output);

/// Initialize array of action/SetMode messages.
/**
 * It allocates the memory for the number of elements and calls
 * urinterfaces__action__SetMode_Feedback__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Feedback__Sequence__init(urinterfaces__action__SetMode_Feedback__Sequence * array, size_t size);

/// Finalize array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_Feedback__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_Feedback__Sequence__fini(urinterfaces__action__SetMode_Feedback__Sequence * array);

/// Create array of action/SetMode messages.
/**
 * It allocates the memory for the array and calls
 * urinterfaces__action__SetMode_Feedback__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_Feedback__Sequence *
urinterfaces__action__SetMode_Feedback__Sequence__create(size_t size);

/// Destroy array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_Feedback__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_Feedback__Sequence__destroy(urinterfaces__action__SetMode_Feedback__Sequence * array);

/// Check for action/SetMode message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Feedback__Sequence__are_equal(const urinterfaces__action__SetMode_Feedback__Sequence * lhs, const urinterfaces__action__SetMode_Feedback__Sequence * rhs);

/// Copy an array of action/SetMode messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_Feedback__Sequence__copy(
  const urinterfaces__action__SetMode_Feedback__Sequence * input,
  urinterfaces__action__SetMode_Feedback__Sequence * output);

/// Initialize action/SetMode message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * urinterfaces__action__SetMode_SendGoal_Request
 * )) before or use
 * urinterfaces__action__SetMode_SendGoal_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_SendGoal_Request__init(urinterfaces__action__SetMode_SendGoal_Request * msg);

/// Finalize action/SetMode message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_SendGoal_Request__fini(urinterfaces__action__SetMode_SendGoal_Request * msg);

/// Create action/SetMode message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * urinterfaces__action__SetMode_SendGoal_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_SendGoal_Request *
urinterfaces__action__SetMode_SendGoal_Request__create();

/// Destroy action/SetMode message.
/**
 * It calls
 * urinterfaces__action__SetMode_SendGoal_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_SendGoal_Request__destroy(urinterfaces__action__SetMode_SendGoal_Request * msg);

/// Check for action/SetMode message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_SendGoal_Request__are_equal(const urinterfaces__action__SetMode_SendGoal_Request * lhs, const urinterfaces__action__SetMode_SendGoal_Request * rhs);

/// Copy a action/SetMode message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_SendGoal_Request__copy(
  const urinterfaces__action__SetMode_SendGoal_Request * input,
  urinterfaces__action__SetMode_SendGoal_Request * output);

/// Initialize array of action/SetMode messages.
/**
 * It allocates the memory for the number of elements and calls
 * urinterfaces__action__SetMode_SendGoal_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_SendGoal_Request__Sequence__init(urinterfaces__action__SetMode_SendGoal_Request__Sequence * array, size_t size);

/// Finalize array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_SendGoal_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_SendGoal_Request__Sequence__fini(urinterfaces__action__SetMode_SendGoal_Request__Sequence * array);

/// Create array of action/SetMode messages.
/**
 * It allocates the memory for the array and calls
 * urinterfaces__action__SetMode_SendGoal_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_SendGoal_Request__Sequence *
urinterfaces__action__SetMode_SendGoal_Request__Sequence__create(size_t size);

/// Destroy array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_SendGoal_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_SendGoal_Request__Sequence__destroy(urinterfaces__action__SetMode_SendGoal_Request__Sequence * array);

/// Check for action/SetMode message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_SendGoal_Request__Sequence__are_equal(const urinterfaces__action__SetMode_SendGoal_Request__Sequence * lhs, const urinterfaces__action__SetMode_SendGoal_Request__Sequence * rhs);

/// Copy an array of action/SetMode messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_SendGoal_Request__Sequence__copy(
  const urinterfaces__action__SetMode_SendGoal_Request__Sequence * input,
  urinterfaces__action__SetMode_SendGoal_Request__Sequence * output);

/// Initialize action/SetMode message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * urinterfaces__action__SetMode_SendGoal_Response
 * )) before or use
 * urinterfaces__action__SetMode_SendGoal_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_SendGoal_Response__init(urinterfaces__action__SetMode_SendGoal_Response * msg);

/// Finalize action/SetMode message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_SendGoal_Response__fini(urinterfaces__action__SetMode_SendGoal_Response * msg);

/// Create action/SetMode message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * urinterfaces__action__SetMode_SendGoal_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_SendGoal_Response *
urinterfaces__action__SetMode_SendGoal_Response__create();

/// Destroy action/SetMode message.
/**
 * It calls
 * urinterfaces__action__SetMode_SendGoal_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_SendGoal_Response__destroy(urinterfaces__action__SetMode_SendGoal_Response * msg);

/// Check for action/SetMode message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_SendGoal_Response__are_equal(const urinterfaces__action__SetMode_SendGoal_Response * lhs, const urinterfaces__action__SetMode_SendGoal_Response * rhs);

/// Copy a action/SetMode message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_SendGoal_Response__copy(
  const urinterfaces__action__SetMode_SendGoal_Response * input,
  urinterfaces__action__SetMode_SendGoal_Response * output);

/// Initialize array of action/SetMode messages.
/**
 * It allocates the memory for the number of elements and calls
 * urinterfaces__action__SetMode_SendGoal_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_SendGoal_Response__Sequence__init(urinterfaces__action__SetMode_SendGoal_Response__Sequence * array, size_t size);

/// Finalize array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_SendGoal_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_SendGoal_Response__Sequence__fini(urinterfaces__action__SetMode_SendGoal_Response__Sequence * array);

/// Create array of action/SetMode messages.
/**
 * It allocates the memory for the array and calls
 * urinterfaces__action__SetMode_SendGoal_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_SendGoal_Response__Sequence *
urinterfaces__action__SetMode_SendGoal_Response__Sequence__create(size_t size);

/// Destroy array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_SendGoal_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_SendGoal_Response__Sequence__destroy(urinterfaces__action__SetMode_SendGoal_Response__Sequence * array);

/// Check for action/SetMode message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_SendGoal_Response__Sequence__are_equal(const urinterfaces__action__SetMode_SendGoal_Response__Sequence * lhs, const urinterfaces__action__SetMode_SendGoal_Response__Sequence * rhs);

/// Copy an array of action/SetMode messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_SendGoal_Response__Sequence__copy(
  const urinterfaces__action__SetMode_SendGoal_Response__Sequence * input,
  urinterfaces__action__SetMode_SendGoal_Response__Sequence * output);

/// Initialize action/SetMode message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * urinterfaces__action__SetMode_GetResult_Request
 * )) before or use
 * urinterfaces__action__SetMode_GetResult_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_GetResult_Request__init(urinterfaces__action__SetMode_GetResult_Request * msg);

/// Finalize action/SetMode message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_GetResult_Request__fini(urinterfaces__action__SetMode_GetResult_Request * msg);

/// Create action/SetMode message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * urinterfaces__action__SetMode_GetResult_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_GetResult_Request *
urinterfaces__action__SetMode_GetResult_Request__create();

/// Destroy action/SetMode message.
/**
 * It calls
 * urinterfaces__action__SetMode_GetResult_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_GetResult_Request__destroy(urinterfaces__action__SetMode_GetResult_Request * msg);

/// Check for action/SetMode message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_GetResult_Request__are_equal(const urinterfaces__action__SetMode_GetResult_Request * lhs, const urinterfaces__action__SetMode_GetResult_Request * rhs);

/// Copy a action/SetMode message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_GetResult_Request__copy(
  const urinterfaces__action__SetMode_GetResult_Request * input,
  urinterfaces__action__SetMode_GetResult_Request * output);

/// Initialize array of action/SetMode messages.
/**
 * It allocates the memory for the number of elements and calls
 * urinterfaces__action__SetMode_GetResult_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_GetResult_Request__Sequence__init(urinterfaces__action__SetMode_GetResult_Request__Sequence * array, size_t size);

/// Finalize array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_GetResult_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_GetResult_Request__Sequence__fini(urinterfaces__action__SetMode_GetResult_Request__Sequence * array);

/// Create array of action/SetMode messages.
/**
 * It allocates the memory for the array and calls
 * urinterfaces__action__SetMode_GetResult_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_GetResult_Request__Sequence *
urinterfaces__action__SetMode_GetResult_Request__Sequence__create(size_t size);

/// Destroy array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_GetResult_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_GetResult_Request__Sequence__destroy(urinterfaces__action__SetMode_GetResult_Request__Sequence * array);

/// Check for action/SetMode message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_GetResult_Request__Sequence__are_equal(const urinterfaces__action__SetMode_GetResult_Request__Sequence * lhs, const urinterfaces__action__SetMode_GetResult_Request__Sequence * rhs);

/// Copy an array of action/SetMode messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_GetResult_Request__Sequence__copy(
  const urinterfaces__action__SetMode_GetResult_Request__Sequence * input,
  urinterfaces__action__SetMode_GetResult_Request__Sequence * output);

/// Initialize action/SetMode message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * urinterfaces__action__SetMode_GetResult_Response
 * )) before or use
 * urinterfaces__action__SetMode_GetResult_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_GetResult_Response__init(urinterfaces__action__SetMode_GetResult_Response * msg);

/// Finalize action/SetMode message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_GetResult_Response__fini(urinterfaces__action__SetMode_GetResult_Response * msg);

/// Create action/SetMode message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * urinterfaces__action__SetMode_GetResult_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_GetResult_Response *
urinterfaces__action__SetMode_GetResult_Response__create();

/// Destroy action/SetMode message.
/**
 * It calls
 * urinterfaces__action__SetMode_GetResult_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_GetResult_Response__destroy(urinterfaces__action__SetMode_GetResult_Response * msg);

/// Check for action/SetMode message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_GetResult_Response__are_equal(const urinterfaces__action__SetMode_GetResult_Response * lhs, const urinterfaces__action__SetMode_GetResult_Response * rhs);

/// Copy a action/SetMode message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_GetResult_Response__copy(
  const urinterfaces__action__SetMode_GetResult_Response * input,
  urinterfaces__action__SetMode_GetResult_Response * output);

/// Initialize array of action/SetMode messages.
/**
 * It allocates the memory for the number of elements and calls
 * urinterfaces__action__SetMode_GetResult_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_GetResult_Response__Sequence__init(urinterfaces__action__SetMode_GetResult_Response__Sequence * array, size_t size);

/// Finalize array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_GetResult_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_GetResult_Response__Sequence__fini(urinterfaces__action__SetMode_GetResult_Response__Sequence * array);

/// Create array of action/SetMode messages.
/**
 * It allocates the memory for the array and calls
 * urinterfaces__action__SetMode_GetResult_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_GetResult_Response__Sequence *
urinterfaces__action__SetMode_GetResult_Response__Sequence__create(size_t size);

/// Destroy array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_GetResult_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_GetResult_Response__Sequence__destroy(urinterfaces__action__SetMode_GetResult_Response__Sequence * array);

/// Check for action/SetMode message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_GetResult_Response__Sequence__are_equal(const urinterfaces__action__SetMode_GetResult_Response__Sequence * lhs, const urinterfaces__action__SetMode_GetResult_Response__Sequence * rhs);

/// Copy an array of action/SetMode messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_GetResult_Response__Sequence__copy(
  const urinterfaces__action__SetMode_GetResult_Response__Sequence * input,
  urinterfaces__action__SetMode_GetResult_Response__Sequence * output);

/// Initialize action/SetMode message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * urinterfaces__action__SetMode_FeedbackMessage
 * )) before or use
 * urinterfaces__action__SetMode_FeedbackMessage__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_FeedbackMessage__init(urinterfaces__action__SetMode_FeedbackMessage * msg);

/// Finalize action/SetMode message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_FeedbackMessage__fini(urinterfaces__action__SetMode_FeedbackMessage * msg);

/// Create action/SetMode message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * urinterfaces__action__SetMode_FeedbackMessage__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_FeedbackMessage *
urinterfaces__action__SetMode_FeedbackMessage__create();

/// Destroy action/SetMode message.
/**
 * It calls
 * urinterfaces__action__SetMode_FeedbackMessage__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_FeedbackMessage__destroy(urinterfaces__action__SetMode_FeedbackMessage * msg);

/// Check for action/SetMode message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_FeedbackMessage__are_equal(const urinterfaces__action__SetMode_FeedbackMessage * lhs, const urinterfaces__action__SetMode_FeedbackMessage * rhs);

/// Copy a action/SetMode message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_FeedbackMessage__copy(
  const urinterfaces__action__SetMode_FeedbackMessage * input,
  urinterfaces__action__SetMode_FeedbackMessage * output);

/// Initialize array of action/SetMode messages.
/**
 * It allocates the memory for the number of elements and calls
 * urinterfaces__action__SetMode_FeedbackMessage__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_FeedbackMessage__Sequence__init(urinterfaces__action__SetMode_FeedbackMessage__Sequence * array, size_t size);

/// Finalize array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_FeedbackMessage__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_FeedbackMessage__Sequence__fini(urinterfaces__action__SetMode_FeedbackMessage__Sequence * array);

/// Create array of action/SetMode messages.
/**
 * It allocates the memory for the array and calls
 * urinterfaces__action__SetMode_FeedbackMessage__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__action__SetMode_FeedbackMessage__Sequence *
urinterfaces__action__SetMode_FeedbackMessage__Sequence__create(size_t size);

/// Destroy array of action/SetMode messages.
/**
 * It calls
 * urinterfaces__action__SetMode_FeedbackMessage__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__action__SetMode_FeedbackMessage__Sequence__destroy(urinterfaces__action__SetMode_FeedbackMessage__Sequence * array);

/// Check for action/SetMode message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_FeedbackMessage__Sequence__are_equal(const urinterfaces__action__SetMode_FeedbackMessage__Sequence * lhs, const urinterfaces__action__SetMode_FeedbackMessage__Sequence * rhs);

/// Copy an array of action/SetMode messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__action__SetMode_FeedbackMessage__Sequence__copy(
  const urinterfaces__action__SetMode_FeedbackMessage__Sequence * input,
  urinterfaces__action__SetMode_FeedbackMessage__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // URINTERFACES__ACTION__DETAIL__SET_MODE__FUNCTIONS_H_
