// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from urinterfaces:msg/ActiveTCP.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__MSG__DETAIL__ACTIVE_TCP__STRUCT_HPP_
#define URINTERFACES__MSG__DETAIL__ACTIVE_TCP__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__urinterfaces__msg__ActiveTCP __attribute__((deprecated))
#else
# define DEPRECATED__urinterfaces__msg__ActiveTCP __declspec(deprecated)
#endif

namespace urinterfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ActiveTCP_
{
  using Type = ActiveTCP_<ContainerAllocator>;

  explicit ActiveTCP_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->data = "";
    }
  }

  explicit ActiveTCP_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    data(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->data = "";
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _data_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _data_type data;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__data(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->data = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    urinterfaces::msg::ActiveTCP_<ContainerAllocator> *;
  using ConstRawPtr =
    const urinterfaces::msg::ActiveTCP_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<urinterfaces::msg::ActiveTCP_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<urinterfaces::msg::ActiveTCP_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::ActiveTCP_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::ActiveTCP_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::ActiveTCP_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::ActiveTCP_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<urinterfaces::msg::ActiveTCP_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<urinterfaces::msg::ActiveTCP_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__urinterfaces__msg__ActiveTCP
    std::shared_ptr<urinterfaces::msg::ActiveTCP_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__urinterfaces__msg__ActiveTCP
    std::shared_ptr<urinterfaces::msg::ActiveTCP_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ActiveTCP_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->data != other.data) {
      return false;
    }
    return true;
  }
  bool operator!=(const ActiveTCP_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ActiveTCP_

// alias to use template instance with default allocator
using ActiveTCP =
  urinterfaces::msg::ActiveTCP_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace urinterfaces

#endif  // URINTERFACES__MSG__DETAIL__ACTIVE_TCP__STRUCT_HPP_
