// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from urinterfaces:msg/AnalogIO.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__MSG__DETAIL__ANALOG_IO__STRUCT_HPP_
#define URINTERFACES__MSG__DETAIL__ANALOG_IO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'analog_inputs'
// Member 'analog_outputs'
#include "urinterfaces/msg/detail/analog__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__urinterfaces__msg__AnalogIO __attribute__((deprecated))
#else
# define DEPRECATED__urinterfaces__msg__AnalogIO __declspec(deprecated)
#endif

namespace urinterfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AnalogIO_
{
  using Type = AnalogIO_<ContainerAllocator>;

  explicit AnalogIO_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit AnalogIO_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _analog_inputs_type =
    std::vector<urinterfaces::msg::Analog_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<urinterfaces::msg::Analog_<ContainerAllocator>>>;
  _analog_inputs_type analog_inputs;
  using _analog_outputs_type =
    std::vector<urinterfaces::msg::Analog_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<urinterfaces::msg::Analog_<ContainerAllocator>>>;
  _analog_outputs_type analog_outputs;

  // setters for named parameter idiom
  Type & set__analog_inputs(
    const std::vector<urinterfaces::msg::Analog_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<urinterfaces::msg::Analog_<ContainerAllocator>>> & _arg)
  {
    this->analog_inputs = _arg;
    return *this;
  }
  Type & set__analog_outputs(
    const std::vector<urinterfaces::msg::Analog_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<urinterfaces::msg::Analog_<ContainerAllocator>>> & _arg)
  {
    this->analog_outputs = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    urinterfaces::msg::AnalogIO_<ContainerAllocator> *;
  using ConstRawPtr =
    const urinterfaces::msg::AnalogIO_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<urinterfaces::msg::AnalogIO_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<urinterfaces::msg::AnalogIO_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::AnalogIO_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::AnalogIO_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::AnalogIO_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::AnalogIO_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<urinterfaces::msg::AnalogIO_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<urinterfaces::msg::AnalogIO_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__urinterfaces__msg__AnalogIO
    std::shared_ptr<urinterfaces::msg::AnalogIO_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__urinterfaces__msg__AnalogIO
    std::shared_ptr<urinterfaces::msg::AnalogIO_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AnalogIO_ & other) const
  {
    if (this->analog_inputs != other.analog_inputs) {
      return false;
    }
    if (this->analog_outputs != other.analog_outputs) {
      return false;
    }
    return true;
  }
  bool operator!=(const AnalogIO_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AnalogIO_

// alias to use template instance with default allocator
using AnalogIO =
  urinterfaces::msg::AnalogIO_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace urinterfaces

#endif  // URINTERFACES__MSG__DETAIL__ANALOG_IO__STRUCT_HPP_
