// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from urinterfaces:msg/AnalogStamped.idl
// generated code does not contain a copyright notice
#include "urinterfaces/msg/detail/analog_stamped__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `data`
#include "urinterfaces/msg/detail/analog__functions.h"

bool
urinterfaces__msg__AnalogStamped__init(urinterfaces__msg__AnalogStamped * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    urinterfaces__msg__AnalogStamped__fini(msg);
    return false;
  }
  // data
  if (!urinterfaces__msg__Analog__init(&msg->data)) {
    urinterfaces__msg__AnalogStamped__fini(msg);
    return false;
  }
  return true;
}

void
urinterfaces__msg__AnalogStamped__fini(urinterfaces__msg__AnalogStamped * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // data
  urinterfaces__msg__Analog__fini(&msg->data);
}

bool
urinterfaces__msg__AnalogStamped__are_equal(const urinterfaces__msg__AnalogStamped * lhs, const urinterfaces__msg__AnalogStamped * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // data
  if (!urinterfaces__msg__Analog__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  return true;
}

bool
urinterfaces__msg__AnalogStamped__copy(
  const urinterfaces__msg__AnalogStamped * input,
  urinterfaces__msg__AnalogStamped * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // data
  if (!urinterfaces__msg__Analog__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  return true;
}

urinterfaces__msg__AnalogStamped *
urinterfaces__msg__AnalogStamped__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  urinterfaces__msg__AnalogStamped * msg = (urinterfaces__msg__AnalogStamped *)allocator.allocate(sizeof(urinterfaces__msg__AnalogStamped), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(urinterfaces__msg__AnalogStamped));
  bool success = urinterfaces__msg__AnalogStamped__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
urinterfaces__msg__AnalogStamped__destroy(urinterfaces__msg__AnalogStamped * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    urinterfaces__msg__AnalogStamped__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
urinterfaces__msg__AnalogStamped__Sequence__init(urinterfaces__msg__AnalogStamped__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  urinterfaces__msg__AnalogStamped * data = NULL;

  if (size) {
    data = (urinterfaces__msg__AnalogStamped *)allocator.zero_allocate(size, sizeof(urinterfaces__msg__AnalogStamped), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = urinterfaces__msg__AnalogStamped__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        urinterfaces__msg__AnalogStamped__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
urinterfaces__msg__AnalogStamped__Sequence__fini(urinterfaces__msg__AnalogStamped__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      urinterfaces__msg__AnalogStamped__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

urinterfaces__msg__AnalogStamped__Sequence *
urinterfaces__msg__AnalogStamped__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  urinterfaces__msg__AnalogStamped__Sequence * array = (urinterfaces__msg__AnalogStamped__Sequence *)allocator.allocate(sizeof(urinterfaces__msg__AnalogStamped__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = urinterfaces__msg__AnalogStamped__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
urinterfaces__msg__AnalogStamped__Sequence__destroy(urinterfaces__msg__AnalogStamped__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    urinterfaces__msg__AnalogStamped__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
urinterfaces__msg__AnalogStamped__Sequence__are_equal(const urinterfaces__msg__AnalogStamped__Sequence * lhs, const urinterfaces__msg__AnalogStamped__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!urinterfaces__msg__AnalogStamped__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
urinterfaces__msg__AnalogStamped__Sequence__copy(
  const urinterfaces__msg__AnalogStamped__Sequence * input,
  urinterfaces__msg__AnalogStamped__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(urinterfaces__msg__AnalogStamped);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    urinterfaces__msg__AnalogStamped * data =
      (urinterfaces__msg__AnalogStamped *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!urinterfaces__msg__AnalogStamped__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          urinterfaces__msg__AnalogStamped__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!urinterfaces__msg__AnalogStamped__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
