// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from urinterfaces:msg/DigitalIOStateStamped.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__MSG__DETAIL__DIGITAL_IO_STATE_STAMPED__STRUCT_HPP_
#define URINTERFACES__MSG__DETAIL__DIGITAL_IO_STATE_STAMPED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'configurable_io'
// Member 'standard_io'
#include "urinterfaces/msg/detail/digital_io__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__urinterfaces__msg__DigitalIOStateStamped __attribute__((deprecated))
#else
# define DEPRECATED__urinterfaces__msg__DigitalIOStateStamped __declspec(deprecated)
#endif

namespace urinterfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DigitalIOStateStamped_
{
  using Type = DigitalIOStateStamped_<ContainerAllocator>;

  explicit DigitalIOStateStamped_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    configurable_io(_init),
    standard_io(_init)
  {
    (void)_init;
  }

  explicit DigitalIOStateStamped_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    configurable_io(_alloc, _init),
    standard_io(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _configurable_io_type =
    urinterfaces::msg::DigitalIO_<ContainerAllocator>;
  _configurable_io_type configurable_io;
  using _standard_io_type =
    urinterfaces::msg::DigitalIO_<ContainerAllocator>;
  _standard_io_type standard_io;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__configurable_io(
    const urinterfaces::msg::DigitalIO_<ContainerAllocator> & _arg)
  {
    this->configurable_io = _arg;
    return *this;
  }
  Type & set__standard_io(
    const urinterfaces::msg::DigitalIO_<ContainerAllocator> & _arg)
  {
    this->standard_io = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    urinterfaces::msg::DigitalIOStateStamped_<ContainerAllocator> *;
  using ConstRawPtr =
    const urinterfaces::msg::DigitalIOStateStamped_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<urinterfaces::msg::DigitalIOStateStamped_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<urinterfaces::msg::DigitalIOStateStamped_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::DigitalIOStateStamped_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::DigitalIOStateStamped_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::DigitalIOStateStamped_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::DigitalIOStateStamped_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<urinterfaces::msg::DigitalIOStateStamped_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<urinterfaces::msg::DigitalIOStateStamped_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__urinterfaces__msg__DigitalIOStateStamped
    std::shared_ptr<urinterfaces::msg::DigitalIOStateStamped_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__urinterfaces__msg__DigitalIOStateStamped
    std::shared_ptr<urinterfaces::msg::DigitalIOStateStamped_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DigitalIOStateStamped_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->configurable_io != other.configurable_io) {
      return false;
    }
    if (this->standard_io != other.standard_io) {
      return false;
    }
    return true;
  }
  bool operator!=(const DigitalIOStateStamped_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DigitalIOStateStamped_

// alias to use template instance with default allocator
using DigitalIOStateStamped =
  urinterfaces::msg::DigitalIOStateStamped_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace urinterfaces

#endif  // URINTERFACES__MSG__DETAIL__DIGITAL_IO_STATE_STAMPED__STRUCT_HPP_
