// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from urinterfaces:msg/DigitalStamped.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__MSG__DETAIL__DIGITAL_STAMPED__STRUCT_HPP_
#define URINTERFACES__MSG__DETAIL__DIGITAL_STAMPED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'data'
#include "urinterfaces/msg/detail/digital__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__urinterfaces__msg__DigitalStamped __attribute__((deprecated))
#else
# define DEPRECATED__urinterfaces__msg__DigitalStamped __declspec(deprecated)
#endif

namespace urinterfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DigitalStamped_
{
  using Type = DigitalStamped_<ContainerAllocator>;

  explicit DigitalStamped_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    data(_init)
  {
    (void)_init;
  }

  explicit DigitalStamped_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    data(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _data_type =
    urinterfaces::msg::Digital_<ContainerAllocator>;
  _data_type data;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__data(
    const urinterfaces::msg::Digital_<ContainerAllocator> & _arg)
  {
    this->data = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    urinterfaces::msg::DigitalStamped_<ContainerAllocator> *;
  using ConstRawPtr =
    const urinterfaces::msg::DigitalStamped_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<urinterfaces::msg::DigitalStamped_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<urinterfaces::msg::DigitalStamped_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::DigitalStamped_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::DigitalStamped_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::DigitalStamped_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::DigitalStamped_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<urinterfaces::msg::DigitalStamped_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<urinterfaces::msg::DigitalStamped_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__urinterfaces__msg__DigitalStamped
    std::shared_ptr<urinterfaces::msg::DigitalStamped_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__urinterfaces__msg__DigitalStamped
    std::shared_ptr<urinterfaces::msg::DigitalStamped_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DigitalStamped_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->data != other.data) {
      return false;
    }
    return true;
  }
  bool operator!=(const DigitalStamped_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DigitalStamped_

// alias to use template instance with default allocator
using DigitalStamped =
  urinterfaces::msg::DigitalStamped_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace urinterfaces

#endif  // URINTERFACES__MSG__DETAIL__DIGITAL_STAMPED__STRUCT_HPP_
