// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from urinterfaces:srv/SetAnalogOutput.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__SRV__DETAIL__SET_ANALOG_OUTPUT__TRAITS_HPP_
#define URINTERFACES__SRV__DETAIL__SET_ANALOG_OUTPUT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "urinterfaces/srv/detail/set_analog_output__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'data'
#include "urinterfaces/msg/detail/analog__traits.hpp"

namespace urinterfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetAnalogOutput_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: data
  {
    if (msg.data.size() == 0) {
      out << "data: []";
    } else {
      out << "data: [";
      size_t pending_items = msg.data.size();
      for (auto item : msg.data) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetAnalogOutput_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data.size() == 0) {
      out << "data: []\n";
    } else {
      out << "data:\n";
      for (auto item : msg.data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetAnalogOutput_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace urinterfaces

namespace rosidl_generator_traits
{

[[deprecated("use urinterfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const urinterfaces::srv::SetAnalogOutput_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  urinterfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use urinterfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const urinterfaces::srv::SetAnalogOutput_Request & msg)
{
  return urinterfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<urinterfaces::srv::SetAnalogOutput_Request>()
{
  return "urinterfaces::srv::SetAnalogOutput_Request";
}

template<>
inline const char * name<urinterfaces::srv::SetAnalogOutput_Request>()
{
  return "urinterfaces/srv/SetAnalogOutput_Request";
}

template<>
struct has_fixed_size<urinterfaces::srv::SetAnalogOutput_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<urinterfaces::srv::SetAnalogOutput_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<urinterfaces::srv::SetAnalogOutput_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace urinterfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetAnalogOutput_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetAnalogOutput_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetAnalogOutput_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace urinterfaces

namespace rosidl_generator_traits
{

[[deprecated("use urinterfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const urinterfaces::srv::SetAnalogOutput_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  urinterfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use urinterfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const urinterfaces::srv::SetAnalogOutput_Response & msg)
{
  return urinterfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<urinterfaces::srv::SetAnalogOutput_Response>()
{
  return "urinterfaces::srv::SetAnalogOutput_Response";
}

template<>
inline const char * name<urinterfaces::srv::SetAnalogOutput_Response>()
{
  return "urinterfaces/srv/SetAnalogOutput_Response";
}

template<>
struct has_fixed_size<urinterfaces::srv::SetAnalogOutput_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<urinterfaces::srv::SetAnalogOutput_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<urinterfaces::srv::SetAnalogOutput_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<urinterfaces::srv::SetAnalogOutput>()
{
  return "urinterfaces::srv::SetAnalogOutput";
}

template<>
inline const char * name<urinterfaces::srv::SetAnalogOutput>()
{
  return "urinterfaces/srv/SetAnalogOutput";
}

template<>
struct has_fixed_size<urinterfaces::srv::SetAnalogOutput>
  : std::integral_constant<
    bool,
    has_fixed_size<urinterfaces::srv::SetAnalogOutput_Request>::value &&
    has_fixed_size<urinterfaces::srv::SetAnalogOutput_Response>::value
  >
{
};

template<>
struct has_bounded_size<urinterfaces::srv::SetAnalogOutput>
  : std::integral_constant<
    bool,
    has_bounded_size<urinterfaces::srv::SetAnalogOutput_Request>::value &&
    has_bounded_size<urinterfaces::srv::SetAnalogOutput_Response>::value
  >
{
};

template<>
struct is_service<urinterfaces::srv::SetAnalogOutput>
  : std::true_type
{
};

template<>
struct is_service_request<urinterfaces::srv::SetAnalogOutput_Request>
  : std::true_type
{
};

template<>
struct is_service_response<urinterfaces::srv::SetAnalogOutput_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // URINTERFACES__SRV__DETAIL__SET_ANALOG_OUTPUT__TRAITS_HPP_
