// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from urinterfaces:msg/DigitalIO.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "urinterfaces/msg/detail/digital_io__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace urinterfaces
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void DigitalIO_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) urinterfaces::msg::DigitalIO(_init);
}

void DigitalIO_fini_function(void * message_memory)
{
  auto typed_message = static_cast<urinterfaces::msg::DigitalIO *>(message_memory);
  typed_message->~DigitalIO();
}

size_t size_function__DigitalIO__digital_inputs(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<urinterfaces::msg::Digital> *>(untyped_member);
  return member->size();
}

const void * get_const_function__DigitalIO__digital_inputs(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<urinterfaces::msg::Digital> *>(untyped_member);
  return &member[index];
}

void * get_function__DigitalIO__digital_inputs(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<urinterfaces::msg::Digital> *>(untyped_member);
  return &member[index];
}

void fetch_function__DigitalIO__digital_inputs(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const urinterfaces::msg::Digital *>(
    get_const_function__DigitalIO__digital_inputs(untyped_member, index));
  auto & value = *reinterpret_cast<urinterfaces::msg::Digital *>(untyped_value);
  value = item;
}

void assign_function__DigitalIO__digital_inputs(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<urinterfaces::msg::Digital *>(
    get_function__DigitalIO__digital_inputs(untyped_member, index));
  const auto & value = *reinterpret_cast<const urinterfaces::msg::Digital *>(untyped_value);
  item = value;
}

void resize_function__DigitalIO__digital_inputs(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<urinterfaces::msg::Digital> *>(untyped_member);
  member->resize(size);
}

size_t size_function__DigitalIO__digital_outputs(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<urinterfaces::msg::Digital> *>(untyped_member);
  return member->size();
}

const void * get_const_function__DigitalIO__digital_outputs(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<urinterfaces::msg::Digital> *>(untyped_member);
  return &member[index];
}

void * get_function__DigitalIO__digital_outputs(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<urinterfaces::msg::Digital> *>(untyped_member);
  return &member[index];
}

void fetch_function__DigitalIO__digital_outputs(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const urinterfaces::msg::Digital *>(
    get_const_function__DigitalIO__digital_outputs(untyped_member, index));
  auto & value = *reinterpret_cast<urinterfaces::msg::Digital *>(untyped_value);
  value = item;
}

void assign_function__DigitalIO__digital_outputs(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<urinterfaces::msg::Digital *>(
    get_function__DigitalIO__digital_outputs(untyped_member, index));
  const auto & value = *reinterpret_cast<const urinterfaces::msg::Digital *>(untyped_value);
  item = value;
}

void resize_function__DigitalIO__digital_outputs(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<urinterfaces::msg::Digital> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember DigitalIO_message_member_array[2] = {
  {
    "digital_inputs",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<urinterfaces::msg::Digital>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(urinterfaces::msg::DigitalIO, digital_inputs),  // bytes offset in struct
    nullptr,  // default value
    size_function__DigitalIO__digital_inputs,  // size() function pointer
    get_const_function__DigitalIO__digital_inputs,  // get_const(index) function pointer
    get_function__DigitalIO__digital_inputs,  // get(index) function pointer
    fetch_function__DigitalIO__digital_inputs,  // fetch(index, &value) function pointer
    assign_function__DigitalIO__digital_inputs,  // assign(index, value) function pointer
    resize_function__DigitalIO__digital_inputs  // resize(index) function pointer
  },
  {
    "digital_outputs",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<urinterfaces::msg::Digital>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(urinterfaces::msg::DigitalIO, digital_outputs),  // bytes offset in struct
    nullptr,  // default value
    size_function__DigitalIO__digital_outputs,  // size() function pointer
    get_const_function__DigitalIO__digital_outputs,  // get_const(index) function pointer
    get_function__DigitalIO__digital_outputs,  // get(index) function pointer
    fetch_function__DigitalIO__digital_outputs,  // fetch(index, &value) function pointer
    assign_function__DigitalIO__digital_outputs,  // assign(index, value) function pointer
    resize_function__DigitalIO__digital_outputs  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers DigitalIO_message_members = {
  "urinterfaces::msg",  // message namespace
  "DigitalIO",  // message name
  2,  // number of fields
  sizeof(urinterfaces::msg::DigitalIO),
  DigitalIO_message_member_array,  // message members
  DigitalIO_init_function,  // function to initialize message memory (memory has to be allocated)
  DigitalIO_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t DigitalIO_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &DigitalIO_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace urinterfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<urinterfaces::msg::DigitalIO>()
{
  return &::urinterfaces::msg::rosidl_typesupport_introspection_cpp::DigitalIO_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, urinterfaces, msg, DigitalIO)() {
  return &::urinterfaces::msg::rosidl_typesupport_introspection_cpp::DigitalIO_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
